<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoEndereco extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();

        $nrcependereco      = $itens['NRCEPENDERECO']       ?? null;
        $cdtipoendereco     = $itens['CDTIPOENDERECO']      ?? null;
        $cdpais             = $itens['CDPAIS']              ?? null;
        $sgestado           = $itens['SGESTADO']            ?? null;
        $cdmunicipio        = $itens['CDMUNICIPIO']         ?? null;
        $nmbairroendereco   = $itens['NMBAIRROENDERECO']    ?? null;
        $cdlogradouro       = $itens['CDLOGRADOURO']        ?? null;
        $dsendereco         = $itens['DSENDERECO']          ?? null;
        $nrimovelendereco   = $itens['NRIMOVELENDERECO']    ?? null;
        $dscompleendereco   = $itens['DSCOMPLEENDERECO']    ?? null;
        $dsreferenciaende   = $itens['DSREFERENCIAENDE']    ?? null;
        $nrorg              = Utils::getParamters()->getNrorg();
        $nrvinculom         = $this->getSolicitacao()->getNrvinculom();
        
        if(!isset($cdtipoendereco)) {
            throw new \Exception("Solicitação sem tipo do endereço informado. Favor reprovar e incluir uma nova solicitação");
        }
        
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculom));
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> $nrorg,"nrpessoa" => $result->getNrpessoa()));

        $endereco = Utils::getEntityManager()->getRepository(Repositories::ENDERECOPARC)->findOneBy(array("nrorg"=> $nrorg,"nrparcnegocio" => $result->getNrparcnegocio(), "cdtipoendereco" => $cdtipoendereco));

        if(!$endereco) {
            $enderecoParc = Repositories::ENDERECOPARC;
            $endereco = new $enderecoParc;
            $endereco->setNrenderecoparc(NovoCodigo::geraCodigo(Utils::getParamters()->getNrorg(), 'ENDERECOPARC', 1, 12, true));
            $endereco->setNrparcnegocio($result->getNrparcnegocio());
            $endereco->setCdtipoendereco($cdtipoendereco);
            $endereco->setNrorg(Utils::getParamters()->getNrorg());
            $endereco->setDtinclusao(DateUtil::getDataAtual(false));
            $endereco->setNrorginclusao(Utils::getParamters()->getNrorg());
            $endereco->setCdoperinclusao(Utils::getParamters()->getCdoperador());
            
        }
        
        $endereco->setCdlogradouro($cdlogradouro);
        $endereco->setCdmunicipio($cdmunicipio);
        $endereco->setCdpais($cdpais);
        $endereco->setDsendereco($dsendereco);
        $endereco->setNmbairroendereco($nmbairroendereco);
        $endereco->setNrcependereco($nrcependereco);
        $endereco->setNrimovelendereco($nrimovelendereco);
        $endereco->setDscompleendereco($dscompleendereco);
        $endereco->setDsreferenciaende($dsreferenciaende);
        $endereco->setSgestado($sgestado);
        $endereco->setDtultatu(DateUtil::getDataAtual(false));
        $endereco->setNrorgultatu(Utils::getParamters()->getNrorg());
        $endereco->setCdoperultatu(Utils::getParamters()->getCdoperador());
        
        Utils::getEntityManager()->persist($endereco);
        Utils::getEntityManager()->flush();
    }
    
    public function rejeitar() {}
}