CREATE OR REPLACE TRIGGER LOG_ALCADAGERFILI
AFTER DELETE OR INSERT OR UPDATE
ON ALCADAGERFILI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Inclusão, '2' - Alteração, '3' - Exclusão*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      IF NVL(:OLD.NRCONFIGALCADA, 0) <> NVL(:NEW.NRCONFIGALCADA, 0)    THEN
         V_DESC   := V_DESC || 'Alçada:' || '' || NVL(:NEW.NRCONFIGALCADA,  '')  || ' ';
      END IF;
      IF NVL(:OLD.CDFILIAL, '!')   <> NVL(:NEW.CDFILIAL, '!')   THEN
         V_DESC   := V_DESC || 'Unidade:' || '' || NVL(:NEW.CDFILIAL, '')  || ' ';
      END IF;
      IF NVL(:OLD.CDOPERADOR, '!')   <> NVL(:NEW.CDOPERADOR, '!')   THEN
         V_DESC   := V_DESC || 'Aprovador:' || '' || NVL(:NEW.CDOPERADOR, '')  || ' ';
      END IF;
      IF NVL(:OLD.VRAPROVCMP, 0)   <> NVL(:NEW.VRAPROVCMP, 0)   THEN
         V_DESC   := V_DESC || 'Vr/Ordem Aprov:' || '' || :NEW.VRAPROVCMP  || ' ';
      END IF;
      IF NVL(:OLD.IDEXIGJUSTIFICATIVA, '!')   <> NVL(:NEW.IDEXIGJUSTIFICATIVA, '!')   THEN
         V_DESC   := V_DESC || 'Exige Just:' || '' || NVL(:NEW.IDEXIGJUSTIFICATIVA, '')  || ' ';
      END IF;
      V_ITPESQ       := NVL(:OLD.NRCONFIGALCADA||:OLD.CDFILIAL||:OLD.CDOPERADOR, '');
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Alçada:'         || '' || NVL(:NEW.NRCONFIGALCADA, '')  || ' ' ||
                     'Unidade:'        || '' || NVL(:NEW.CDFILIAL, '')        || ' ' ||
				             'Vr/Ordem Aprov:' || '' || NVL(:NEW.VRAPROVCMP, '')      || ' ' ||
                     'Exige Just:'     || '' || NVL(:NEW.IDEXIGJUSTIFICATIVA, '');
         
         V_ITPESQ     := :NEW.NRCONFIGALCADA||:NEW.CDFILIAL||:NEW.CDOPERADOR;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Alçada:'         || '' || NVL(:OLD.NRCONFIGALCADA, '')  || ' ' ||
                        'Unidade:'        || '' || NVL(:OLD.CDFILIAL, '')        || ' ' ||
                        'Vr/Ordem Aprov:' || '' || NVL(:OLD.VRAPROVCMP, '')      || ' ' ||
                        'Exige Just:'     || '' || NVL(:OLD.IDEXIGJUSTIFICATIVA, '');
            
            V_ITPESQ      := NVL(:OLD.NRCONFIGALCADA||:OLD.CDFILIAL||:OLD.CDOPERADOR, '');
            V_IDTIPOOPER  := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
    VALUES
      ('ALCADAGERFILI',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/
